uniform sampler2D diffuseTexture;

uniform vec2 texelSize;

varying vec2 outUV;

void main()
{
	vec4 texColor = texture2D(diffuseTexture, outUV);
	vec3 color = vec3(0.0);
	if(texColor.r<0.5)
		color = texColor.rgb * cross(texColor.rgb, vec3(0.2, texColor.g, 0.6)) + texColor / 2.0;
	else if(texColor.g>0.5)
		color = vec3(texColor.b, cross(texColor.rgb, vec3(0.2, texColor.r, 0.8)).rg) + texColor.brg / 2.0;
	else
		color = (dot(texColor, vec3(0.29, 0.59, 0.12))) * cross(texColor.rgb, vec3(0.5, texColor.b, 0.8)) + texColor / 2.0;
	gl_FragColor = vec4(color, 1.0);
}