uniform vec3 R_fogColor;
uniform float R_fogBegin;
uniform float R_fogEnd;
uniform float R_fogDensity;
uniform int R_fogType;
uniform vec3 T_eyePos;

varying vec3 outPosition;

void main()
{
	float dist = length(T_eyePos - outPosition);
	float fog = 0.0;
	if(R_fogType==0) {
		float fogWidth = R_fogEnd-R_fogBegin;
		fog = clamp((dist-R_fogBegin)/fogWidth, 0.0, 0.9999);
	} else if(R_fogType==1) {
		fog = 1.0-clamp(exp(-R_fogDensity * (dist-R_fogBegin)), 0.0, 0.9999);
	} else {
		fog = 1.0-clamp(exp(-pow((R_fogDensity * (dist-R_fogBegin)), 2.0)), 0.0, 0.9999);
	}
	gl_FragColor = vec4(R_fogColor, fog);
}