varying vec3 outPosition;
uniform mat4 T_modelViewProjectionMatrix;
uniform mat4 T_modelMatrix;
uniform mat4 boneMatrix[64];
attribute vec3 vertex;
attribute vec4 boneId;
attribute vec4 boneWeight;

void main()
{
	mat4 boneTransform = boneMatrix[int(boneId.x)] * boneWeight.x;
	boneTransform += boneMatrix[int(boneId.y)] * boneWeight.y;
	boneTransform += boneMatrix[int(boneId.z)] * boneWeight.z;
	boneTransform += boneMatrix[int(boneId.w)] * boneWeight.w;
	vec4 vertexPosition = boneTransform * vec4(vertex, 1.0);
	gl_Position = T_modelViewProjectionMatrix * vertexPosition;
	outPosition=vec3(T_modelMatrix * vertexPosition);
}