uniform mat4 T_modelViewProjectionMatrix;
uniform mat4 T_modelMatrix;

attribute vec3 vertex;
attribute vec4 color;
attribute vec2 UV;
attribute mat4 instanceMatrix;
attribute vec4 instanceUvAnimation;

varying vec3 outPosition;
varying vec2 outUV;
varying vec4 outColor;

void main()
{
    gl_Position = (T_modelViewProjectionMatrix * instanceMatrix) * vec4(vertex, 1.0);
	outUV=UV * instanceUvAnimation.zw + instanceUvAnimation.xy;
	outPosition=vec3(instanceMatrix * vec4(vertex, 1.0));
	outColor = color;
}