uniform samplerCube diffuseTexture;
uniform samplerCube diffuseTexture2;

varying vec4 outColor;
varying vec3 outVertexVector;

uniform vec3 fogColor;
uniform float lowerLimit;
uniform float upperLimit;
uniform float blendFactor;

void main()
{
	vec4 color = textureCube(diffuseTexture, outVertexVector);
	vec4 color2 = textureCube(diffuseTexture2, outVertexVector);
	vec4 finalColor = mix(color, color2, blendFactor);
	
	float factor = (outVertexVector.y + lowerLimit) / (lowerLimit - upperLimit);
	factor = clamp(factor, 0.0, 1.0);
	gl_FragColor = mix(vec4(fogColor, 1.0), finalColor, factor) * outColor;
}