uniform samplerCube diffuseTexture;

varying vec4 outColor;
varying vec3 outVertexVector;

uniform vec3 fogColor;
uniform float lowerLimit;
uniform float upperLimit;

void main()
{
	vec4 finalColor = textureCube(diffuseTexture, outVertexVector) * outColor;
	
	float factor = (outVertexVector.y + lowerLimit) / (lowerLimit - upperLimit);
	factor = clamp(factor, 0.0, 1.0);
	gl_FragColor = mix(vec4(fogColor, 1.0), finalColor, factor);
}